Title Page

Serial/IP® COM Port Redirector User Guide

Navigation: »No topics above this level«

Serial/IP® COM Port Redirector User Guide

 Return to chapter overview

OEM Edition

Quick Start Guide

Version 4.9

Serial/IP is a registered trademark of Tactical Software, LLC.

Tactical Software is a registered trademark of Tactical Software, LLC.

Copyright © 2016 Tactical Software, LLC.

www.tacticalsoftware.com


DialOut/EZ Quick Start Guide

Serial/IP Quick Start Guide

Navigation: Serial/IP COM Port Redirector User Guide >

Serial/IP Quick Start Guide

 Return to chapter overview

This Quick Start Guide describes how to install and configure the Serial/IP Redirector so that the Windows applications can use virtual COM ports to access networked serial devices.

Configure the Serial Device Server

Make sure that the serial server makes its devices available on a TCP port.

Install the Serial/IP Software

· Log in as Administrator.
· Run the Serial/IP setup program.
· Use all default choices.
· The Serial/IP Redirector will begin running. Windows will not need to be restarted.

Create Virtual COM Ports

In the Select Ports window, select one or more virtual COM ports, and then click OK.

The Serial/IP Select Ports window

Configure a Virtual COM Port

Enter the IP Address of the serial device server. Enter the TCP Port Number that it is listening on.

If the server requires a login, then select the Use Credentials From checkbox. Then in the drop-down list, select Use Credentials Below and enter the Username and Password.

The Serial/IP Control Panel

Run Auto Configure

Click Auto Configure. In the Auto Configure window, click Start. When it completes, click Use Settings.

The correct setting will be made for Connection Protocol.

The Serial/IP Auto Configure window

Ensure that Firewall Software Permits Connections

The Serial/IP setup program will add an exception for Serial/IP in the Microsoft Windows Firewall.

If using other firewall software, then manually add exceptions for UDP port 2392 both inbound and outbound, and TCP port 2392 inbound.

If a firewall blocks outbound connections, then also add exceptions for any outbound TCP ports that will be entered under the Port Number field in Serial/IP.

Configure the Application

If using an application that must use a COM port directly, then change its COM port setting to the virtual COM port.

The application should now be using the device on the serial device server.

Having Issues?

· Check the settings for any firewall software that may affect connections being used by Serial/IP.
· Review the detailed instructions in the rest of the User Guide.

© 2016 Tactical Software LLC


Preparing to Install

Navigation: Serial/IP COM Port Redirector User Guide > Installation >

Preparing to Install

 Return to chapter overview

Local Computer Requirements

The following platforms are supported: Windows 2012, 10, 8, 7, 2008, Vista, 2003, XP and 2000, including all R2, 32-bit (x86) and 64-bit (x64) versions, on native and virtual platforms, including Virtual Server and VMware.

Network Requirements

A TCP/IP network connection from the local computer to the serial device server is needed. The throughput and performance of the network connection must exceed the requirements of the application. An Ethernet-based network will easily meet this requirement, unless hundreds of COM ports are being used.

Firewall Requirements

The installer will add an exception for Serial/IP in the Microsoft Windows Firewall. For other firewall programs, manually add exceptions for UDP port 2392 (both inbound and outbound) and TCP port 2392 inbound. If the firewall blocks outbound connections, then add any outbound TCP ports that are entered under the Port Number field in Serial/IP.

Server Requirements

The server must be configured to provide access to its shared devices via incoming TCP connections.

Information and Software Required

· The Serial/IP Redirector setup program.
· Administrator privileges for the computers on which the redirector will be installed.
· The IP address or hostname of the serial server.
· The TCP port number(s) on which the server will make connections to use its serial devices.


Running the Setup Program

Navigation: Serial/IP COM Port Redirector User Guide > Installation >

Running the Setup Program

 Return to chapter overview

Installing

To install the software, log in as a user with Administrator privileges. Run the Serial/IP setup program and follow its instructions.

To restrict access to the Serial/IP Control Panel to users with Administrator privileges, select the feature Administrator Only Mode during the installation. The redirector will still be usable by anyone. However, the Serial/IP icon in the Windows System Tray will not appear, and the Serial/IP Control Panel will not be accessible.

Removing the Software

To remove the Serial/IP Redirector from the computer, first ensure that no applications are using the Serial/IP COM ports. Then in the Windows Control Panel, open the Programs and Features applet, select the Serial/IP entry, and click Remove. After uninstalling, a restart of Windows will not be necessary.


Creating and Configuring Virtual COM Ports

Navigation: Serial/IP COM Port Redirector User Guide > Installation >

Creating and Configuring Virtual COM Ports

 Return to chapter overview

Creating a Virtual COM Port

The Serial/IP Redirector requires that at least one virtual COM port be created.

The Select Ports window will show a list of COM ports (in the range of COM1 through COM4096) that are not already in use. Any of these unused COM ports can be selected to become Serial/IP COM ports.

To create virtual COM ports, in the Select Ports window, select at least one COM port to be a Serial/IP virtual COM port. Corresponding COM port ranges will appear in the lower panel.

Alternatively, the COM port ranges may be directly edited. Use individual COM port numbers (such as 4, 5, 7) and/or ranges (such as 11-18, 30-53) separated by commas. When editing the COM port ranges, the checkboxes in the upper panel will change accordingly. Click OK when finished.

In order to make the built-in COM ports (e.g., COM1, COM2) on a computer available to be virtual COM ports, then disable these ports in the BIOS, and then remove them from the Windows Device Manager.

Legacy applications may not be able to use COM ports higher than COM4.

Configuring a Virtual COM Port

In this step, the virtual COM port will be configured and tested. The Serial/IP Auto Configure feature will verify the network connection to the server.

In the Serial/IP Control Panel, select a virtual COM port in the list, and then click Auto Configure. In IP Address of Server, type in the IP address or hostname of the serial device server that will be used by this virtual COM port. In Port Number, type in the TCP port number for which the server provides access to the serial device.

If the serial device server requires a user login, then type in the values for the Username and Password to be provided by the redirector when the server prompts for the login.

Select the Test for presence of a modem checkbox only if the serial device is a modem.

Click Start. Messages will appear in the Status and Log Panels that will show the redirector's interaction with the server. It typically takes 5 to 15 seconds to complete.

Click Use Settings after it has completed successfully. The recommended settings will be applied to the virtual COM port.

If the Use Settings button is not highlighted, then messages in the Status Panel will indicate the issue. See the topic Auto Configure for instructions.

The server failover feature allows more than one IP address or hostname to be entered. See the topic The Control Panel for details on how to use this feature.

Specifying the Credentials Source

The redirector can be configured to obtain the username and password credentials from one of four sources. If the server will not require a user login, then skip this step.

In the Serial/IP Control Panel, select the Use Credentials From checkbox, and then choose one of the four credential methods. They are described in detail in The Control Panel section.

If the server is not configured to require user authentication, then the Use Credentials From checkbox must be cleared.

Finishing the Port Settings

If the connection fails, then the redirector can attempt to restore its network connection to the server. To enable this feature for a virtual COM port, select the Restore Failed Connections checkbox.

Configuration of this virtual COM port is now complete.

Configuring Additional Ports

In the Serial/IP Control Panel, select a virtual COM port. If the intention is to use the same server and device, then use the same settings as a previously configured port. Otherwise, configure the COM port by starting at the beginning of this chapter.

To copy the settings of the selected virtual COM port to other virtual COM ports, click Copy Settings To, and then specify the ports that will receive the settings.

Configuring Advanced Options

The Serial/IP Redirector Advanced Options have default values that will work for virtually all applications. Experimentation with these settings is strongly discouraged.

The Advanced Options are described in detail in the Advanced Options section.


Using Virtual COM Ports

Navigation: Serial/IP COM Port Redirector User Guide > Installation >

Using Virtual COM Ports

 Return to chapter overview

Direct Access as COM Ports

To use virtual COM ports directly from the application, find the settings, preferences, or options in the application that will allow configuration of the COM ports that are going to be used. Virtual COM ports will appear, along with any local hardware COM ports.

Select the virtual COM ports to access the device on the serial server. The application will now be able to use this COM port in the same way that it would use a local COM port.

Some older Windows applications will not recognize COM ports higher than COM4. If using such an application, then create virtual COM ports in the COM1-4 range.

A common programming error may cause the application to fail when attempting to open COM10 and above. These applications will be limited to using virtual COM ports COM1-COM9.


The Control Panel

Navigation: Serial/IP COM Port Redirector User Guide > Using the Redirector >

The Control Panel

 Return to chapter overview

Using the Serial/IP Control Panel

There are three ways to get to the Control Panel: In the Serial/IP program group in the Windows Start Menu, click the Control Panel shortcut; or in the Windows System Tray, right-click the Serial/IP icon and click the Configure command; or in the Windows Control Panel, open the Serial/IP applet.

If the Serial/IP Redirector has been installed with the Administrator Only Mode feature, then the Serial/IP Control Panel will only be available to users with Administrator privileges.

To configure a virtual COM port, select a virtual COM port in the list at the left, and then change the settings on the right. Changes will be recorded within two seconds, with no further action. To apply the settings of the current virtual COM port to other ports, click Copy Settings To, and then select the ports to receive the settings.

Advanced Options

To configure Advanced Options for all COM ports, open the Serial/IP Control Panel, and Click Advanced. In the Advanced Settings window, select the Options tab, and then change the settings.

Changed settings will not affect the operation of currently active virtual COM ports. See the Advanced Options section for further details.

Select Ports

The Select Ports command will display a window that allows selection of the Serial/IP COM ports.

To add or remove virtual COM ports in the Serial/IP Control Panel, click Select Ports. Change the installed virtual COM ports by selecting and clearing checkboxes. The corresponding COM port ranges will appear in the lower panel.

Alternatively, the COM port ranges may be edited directly. Use individual COM port numbers (such as 4, 5, 7) and/or ranges (such as 11-18, 30-53), separated by commas. When editing the COM port ranges, the checkboxes in the upper panel will change accordingly. Click OK when finished.

When the redirector is first installed, at least one virtual COM port must be selected. Virtual COM ports may be added and removed, but at least one port must remain.

The list of available COM ports will neither include COM ports for local hardware, nor any virtual COM ports created by other applications (such as printers and Bluetooth devices).

If a virtual COM port is removed and later recreated, then the settings of the previously removed COM port will be applied.

IP Address and Port Number

The IP Address of the Server and Port Number will inform the redirector of the location of the server on the network, and the TCP port number at which the server will provide the device for this virtual COM port. As noted below, up to four servers may be specified.

In the Serial/IP Control Panel, select a virtual COM port. In the IP Address field, type in either an IP address in the form xxx.xxx.xxx.xxx (e.g., 192.9.200.1.), or a hostname (e.g., devserver or devserver.xyz.com).

In Port Number, type in the TCP port number at which the server provides the serial device.

If the Serial/IP Redirector is unable to connect to a server, then the failover feature will attempt to connect to backup servers, if they are specified in IP Address.

To use the failover feature, enter up to four IP addresses or hostnames into IP Address, separated by space characters or commas. Examples: 192.9.200.1 192.9.200.2 or devserver1.xyz.com, devserver2.xyz.com, deserver3.xyz.com

If the redirector is unable to establish a connection to a server, then it will attempt to connect to the next server in the list. Each connection attempt will use the same TCP port number.

By default, the length of time for each connection attempt will be governed by the Windows TCP/IP stack. The duration of the attempt may be limited with the Advanced Option, End Connection Attempt after.

Accept Connections

Serial/IP is able to accept incoming TCP connections from remote devices by selecting the Accept Connections checkbox. For the associated Port Number, type in a TCP port number that is available on the local computer.

Each virtual COM port can be configured for outbound connections, inbound connections, or both.

If Restore Failed Connections is enabled, then it will only function for outbound connections. A failed inbound connection must be re-initiated by the remote device.

User Credentials

If the serial device server requires a login, then the Use Credentials From checkbox must be selected.

When Use Credentials From is selected, the redirector will wait for the server to prompt for a username and password. The virtual COM port can not be used by the application until the login sequence has successfully completed.

The Use Credentials checkbox and drop-down list

To set User Credentials, in the Serial/IP Control Panel, choose a virtual COM port and select the Use Credentials From checkbox. In the drop-down list, select one of the four sources for the credentials:

· Use Credentials Below - The redirector will take the credentials from the Username and Password fields.

· Windows Credentials - The redirector will obtain values for the username and password every time a Windows login occurs. The redirector will have no username or password until the next Windows login. By default, the Advanced Option, Include Domain in Windows Credentials will be enabled, in which the redirector will send the Windows domain name along with the credentials to the server.

· Prompt at Login - Every time a user logs into Windows, the redirector will display a window prompting for a username and password. To change the credentials, click Prompt Now. This option will not be available on multi-user operating systems such as Microsoft Terminal Services and Citrix MetaFrame Access Suite. If a user is not logged in at the time a COM port is opened, then the redirector will proceed as if the Use Credentials From checkbox was not selected.

· Prompt on COM Port Open - Every time an application opens this virtual COM port, the redirector will display a window prompting for a username and password. These credentials will only be applied for this specific use of the virtual COM port. If a user is not logged in at the time a COM port is opened, then the redirector will proceed as if the Use Credentials From checkbox was not selected. If the user clicks Cancel, or does not click OK within 60 seconds, then the redirector will proceed as if credentials were not required for this connection. This option is not available on multi-user operating systems such as Microsoft Terminal Services and Citrix MetaFrame Access Suite.

Connection Protocol

The setting for Connection Protocol defines the TCP/IP network protocol that the redirector will use when connecting to the serial device server.

Auto Configure will reliably detect the correct setting for Connection Protocol. It is important to use the setting that the Auto Configure recommends.

To set the Connection Protocol, in the Serial/IP Control Panel, select a virtual COM port. Then select either Telnet or Raw TCP under Connection Protocols. However, the preferred method is to run Auto Configure and click the Use Settings button after it has completed.

The Raw TCP Connection is the default setting in which the redirector uses a TCP/IP socket connection, with no additional protocol.

When the redirector is set to use the Telnet protocol to connect to the server, additional telnet information can be sent. The COM Port Control protocol is a subset of the Telnet protocol that will be used by the redirector, if it is supported by the server.

Using the Telnet protocol does not mean that the connection will be made on the standard TCP port for Telnet (port 23). The TCP port that is being used will be specified in the Port Number field for the virtual COM port.

DSR / DCD / CTS Emulation

Serial/IP can emulate the behavior of the DSR, DCD, and CTS signals. To set DSR / DCD / CTS Emulation in the Serial/IP Control Panel, select a checkbox. Then in the drop-down list, select an emulation method.

When this setting is not selected, the redirector will not emulate the control signals. If the server supports the COM Port Control protocol, then the signal will track the real-time condition of the signal, as reported by the server. If the server does not support the COM Port Control protocol, then the signal will always indicate as low.

When a setting is Enabled and set to Always High, the corresponding signal will always indicate as high. When it is Enabled and set to Always Low, the signal will always indicate as low. Setting it to Enabled and Track Connection causes the signal to indicate as high when there is a network connection to the server, and as low otherwise.

There is seldom a reason to use DSR / DCD / CTS Emulation. Only check this setting if the application will need a different pattern of signals, other than those being relayed by the redirector from the server, or to compensate for the lack of COM Port Control protocol support in the server.

If Auto Configure detects server support for the COM Port Control protocol, then it will recommend disabling the settings for the signal emulations. If any signal emulation is enabled, then it will override the effects of the COM Port Control protocol.

DTR is Modem Escape

The Serial/IP Redirector can simulate DTR signal transitions.

To set DTR is Modem Escape, in the Serial/IP Control Panel, select the DTR is Modem Escape checkbox.

This feature is primarily used when a modem application (notably Windows Dial-up Networking) requires that the DTR signal be used as a method of telling the modem to enter command mode.

If the Auto Configure detects server support for the COM Port Control protocol, then this option will have no effect.

Restore Failed Connections

This option will make the Serial/IP Redirector attempt to restore failed network connections to the server.

To set Restore Failed Connections, in the Serial/IP Control Panel, select the Restore Failed Connections checkbox.

When this setting is enabled and the redirector notices that the TCP connection is broken, it will immediately attempt to reconnect to the server. The reconnection attempt will fail if the Windows TCP/IP stack indicates a failure, or the interval specified in End Connection Attempt after expires. If a reconnection attempt fails, then the redirector will keep trying at increasing intervals until the connection is restored, or the application closes the virtual COM port.

The Restore Failed Connections option should only be used if the application can continue normal operation after a failed connection becomes restored.


Auto Configure

Auto Configure

Using Auto Configure

The Auto Configure feature will detect and interrogate the serial device server to determine the correct settings. If the server is currently providing a modem, then it can test for its presence as well.

In the Serial/IP Control Panel, select a virtual COM port in the list. If the server requires a user login, then select the correct drop-down option under User Credentials. Then click the Auto Configure button.

In the Auto Configure window, make sure that all of the settings are correct. Then click Start.

As it runs, the Status Panel will show a summary of the server's properties. The Log Panel will show its interaction with the server.

If Auto Configure fails, then it will indicate errors in the Status Panel, with details being shown in the Log Panel. Correct its settings, and then click Start to run it again with the new settings.

When Auto Configure succeeds, it will indicate the successful run in the Status Panel. Click the Use Settings button.

The Copy button can be used to copy the contents of the Status and Log Panels into the Windows clipboard.

Status Panel Messages

· Connected to server - The TCP connection to the server has been established.

· Telnet protocol detected - The server has indicated it supports the Telnet protocol.

· Server signature - This shows the signature sent by the server via the COM Port Control protocol.

· Session completed - Auto Configure has finished interacting with the server.

· Client not licensed for this server - The version of the redirector restricts usage to a specific server manufacturer and model, and this server does not qualify. This occurs when using an OEM version of the redirector with an unsupported server.

· Server connection failure / Error connecting to server IP address / Error sending data - The IP Address and/or TCP Port Number may be incorrect. If the IP Address contains a hostname, then the redirector may have encountered a failure in resolving the hostname.

· Server expecting username - A login prompt was detected, but the Username setting is blank.

· Server expecting password - A password prompt was detected, but the Password setting is blank.

· Username and/or password incorrect - The server will not accept the values being entered for the Username and/or Password. The server may require that the username include the Windows domain, but the Advanced Option, Include Domain in Credentials has not been enabled.

· No login/password prompts received from the server - The settings for the Username and/or Password are not blank, but the server has not issued a login prompt. The server may not be configured to require a login.

· Server requires username/password login - A login prompt was detected, but Use Credentials From has not been selected in the Control Panel.

· "Prompt at Login" selected but no credentials present - In the Control Panel, Prompt at Login has been selected, but no credentials have yet been entered.

· "Windows Credentials" selected but no credentials present - In the Control Panel, Use Windows Credentials has been selected, but no credentials have been stored. This will happen when no user login has occurred since this setting was made.

Log Panel Messages

· Bad IP address - Auto Configure was unable to use the setting of IP Address.

· Server disconnected prematurely - Auto Configure was able to establish a connection to the server, but the connection was terminated by the server before it finished.

· Internal error - Auto Configure received data from the server that it was unable to process.

· CONNREFUSED - The server did not accept a connection on the TCP Port Number. The IP Address may be incorrect.

· NETUNREACH, TIMEDOUT, HOSTUNREACH - The IP Address may be incorrect. The local computer's IP routing table does not contain a route for packets going to the IP Address.

· NAMETOOLONG, AFNOSUPPORT - The IP Address is malformed, or is a non-existent hostname.

· ADDRNOTAVAIL - A server at the IP Address is not available.

· NETDOWN - The network connection has failed, or the IP Address is incorrect.

· CONNABORTED, CONNRESET, NOTCONN, SHUTDOWN, EDISCONN - The server has terminated the connection. The server may have failed.


Advanced Options

Advanced Options

The Advanced Options will affect all Serial/IP COM ports.

COM ports that are currently open will not be affected. Changes will be effective the next time the COM port is opened.

The Serial/IP Advanced Options window

Extend Server Connection by

This option will cause Serial/IP to extend its connection to the server and access to the device for a designated interval that will begin when the application closes the virtual COM port.

A Windows programming technique is to hand off a COM port from one process to another. The underlying assumption is that the second process can open the COM port and connect to the same device.

When this is disabled and the virtual COM port is closed, the redirector will immediately close the network connection to the server. This is the default setting.

When it is enabled, the redirector will maintain its connection to the server for the specified number of seconds after the virtual COM port is closed. Therefore, if the virtual COM port is opened by any application before the interval ends, then it will have access to the same device as the prior user of the virtual COM port.

End Connection Attempt after

When Serial/IP attempts a TCP/IP connection to a server, the connection may fail after a timeout period if the server is unresponsive, or if some other network condition prevents a connection. A connection failure will be detected by the Windows TCP/IP stack based on network activity, and may take 10 to 15 seconds or longer.

When this setting is disabled (which is the default), a TCP/IP connection attempt will fail based solely on processing by the Windows TCP/IP stack.

When this setting is enabled (it will default to 2,000 milliseconds), a TCP/IP connection attempt will fail if either the Windows TCP/IP stack does not succeed, or the specified time period expires, whichever occurs first. If this setting is used, then the redirector will terminate all pending connection attempts if they do not succeed within the specified time.

Update Routing Table Upon COM Port Open

Serial/IP can maintain its IP route to a server on a different subnet by modifying the IP routing table.

When this setting is enabled (which is the default) and a virtual COM port is opened, if the server is not on the same subnet as the local computer, then the redirector will insert a route to the server into the TCP/IP routing table, if such a route does not already exist. When the virtual COM port is closed, the redirector will remove the route that it added.

When this setting is disabled, Serial/IP will not update the IP routing table.

Always Limit Data Rate to COM Port Baud Rate

Serial/IP can be configured to limit the data rate according to the baud rate of the virtual COM port.

When this setting is enabled, the redirector will throttle its output data rate to match the baud rate that is currently in effect on the virtual COM port. There will be no effect on input data rate. If the virtual COM port will be connecting to a server that supports the COM Port Control Protocol, then this setting will have no effect.

When this setting is disabled (which is the default), the output and input data rate will not be limited by the redirector.

If the server supports the COM Port Control Protocol, then the server will be able to exercise control over the rate at which the redirector sends data. Otherwise, if this option is disabled, the redirector will ignore that baud rate setting, and allow the server to accept data as quickly as it can.

Include Domain in Windows Credentials

Some servers that require a user login may also require the username to begin with the Windows domain name.

When this setting is enabled, and the source of User Credentials is Windows Credentials, Serial/IP will add the current Windows domain to the username. If the Windows domain is mydomain and the username is smith, then this option will send the username as mydomain\smith.

When this setting is disabled, or there is any other source of User Credentials besides Windows Credentials being used, this option will have no effect. The username will be sent to the server exactly as it is obtained from the credential source.

Force Name Server

Enabling this option will allow the entry of a Domain Name Server name in its field

The redirector will then use this DNS, instead of the default one selected by Windows.

This option is disabled by default.

Use Default Settings

Clicking the Use Default Settings button will return all of the Advanced Options to their default settings.


Proxy Servers

Proxy Servers

Using Serial/IP with a Proxy Server

Serial/IP supports TCP network connections that are made through a proxy server.

The Serial/IP Redirector supports SOCKS v5, SOCKS v4, and HTTPS. It is compatible with Microsoft ISA (for the SOCKS protocol only), Apache on Linux and Windows, and Squid.

If configuring to use Serial/IP with a proxy server, then in the Serial/IP Control Panel, click Advanced. Click the Proxy Server tab, and select the Use a Proxy Server checkbox.

The Proxy Server tab of Serial/IP Advanced Settings window

If the proxy server requires a login, then type the credentials in the Username and Password fields. The Protocol Type, IP Address, and Port Number are required. When not using the Auto Detect feature, values must be entered in these fields.

To locate the proxy server and detect the settings, select the Auto Detect button. If the automatic detection fails, then type in values for Protocol Type, IP Address, and Port Number. The value of IP Address can be entered as a hostname.

Click Test to use the settings to contact the proxy server, and then click OK to record the settings.

If operation with a proxy server is not working as expected, then use the Test command. This will conduct additional checks that can not be readily performed otherwise. The Auto Detect and Test operations will typically take less than 10 seconds. If either of these operations appear to be hung, then use the Stop button to terminate them.


The Port Monitor

The Port Monitor

The Serial/IP Port Monitor program is used to view and capture session data for analysis and troubleshooting.

Using the Port Monitor

The Serial/IP Port Monitor window

The Serial/IP Port Monitor can be opened in three ways: By double-clicking the Serial/IP icon in the Windows System Tray; or by right-clicking the Serial/IP icon in the Windows System Tray and choosing the Port Monitor; or by clicking Port Monitor in the Serial/IP Control Panel.

Multiple Port Monitor windows may be opened simultaneously and configured separately.

The Activity Panel provides a display of the status of all Serial/IP COM ports.

The Port is the virtual COM port number label for the row, which will always appear. If a presets file will be used, then the preset name for this port will appear in the next column.

The Line signal indicators are:

· TD indicates that data is being sent to the server.

· RD indicates that data is being received from the server.

· TR (DTR) is the signal from the application to the server that indicates when the application opens a virtual COM port. The most common use of DTR is to lower the signal to tell the modem to disconnect.

· DR (DSR) is the signal from the server to the application that indicates when a modem or serial device is connected to the server, and is ready to communicate.

· CD (DCD) is the signal from the server to the application that indicates when a modem has successfully negotiated a connection with another device.

The line signal indicators will only appear when the virtual COM port is in use. The TR, DR, and CD indicators will only appear if the COM Port Control protocol is being used, or if the COM Port Options are enabled.

Trace Log

The Trace Log will provide a detailed, time-stamped display of all Serial/IP COM port operations. When enabled, the display will be updated every one second.

This feature can be used to debug application issues. The Trace Log feature will have some impact on memory usage and system performance, so it is typically only enabled temporarily.

Data that appears in the Trace Window may be copied to the clipboard, or saved to a file for off-line analysis.

Using the Trace Log

The Serial/IP Trace Log window

Open a new Port Monitor window, and click the Trace tab. Select the Enable Trace checkbox. Then start the application that uses Serial/IP COM ports, and recreate the issue that is being debugged.

To save the trace data to a file for off-line analysis, use the File | Save As menu command. This file uses a binary format that preserves all data, and may be opened later in a Trace Window using the File | Open menu command.

To capture the trace data in text format and copy it to the Windows clipboard, use the Edit | Copy menu command. Then the text may be pasted into other Windows applications.

Configuring the Trace Window

Clicking Clear removes all data from the display, and resets the trace data collection mechanism.

Selecting Enable Trace starts the trace data collection and display.

Hex Display toggles the format of the display between ASCII and hexadecimal format.

Auto Scroll displays the most recent trace data continuously.

Always on Top keeps the Trace Window on top of other application windows.

Using the Trace Options menu

Select Ports to Capture reduces the number of ports that are being traced, to a subset of all configured virtual COM ports. For applications that use a large number of COM ports, this feature will reduce the impact of tracing on memory and system performance.

Select Ports to Display reduces the number of ports that will appear in the display, to a subset of the ports being captured. For applications that use a large number of COM ports, this feature will provide a way to focus on ports of interest amongst all of those being captured.

Buffer Size changes the amount of system RAM that will be used for tracing.

System Debug Output sends trace data to the system debug channel, with an optional label.

Transmit events is the data that is written to the virtual COM port. It is shown in green and is preceded by a "»" character.

Receive events is the data that is read from the virtual COM port. It is shown in red and is preceded by a "«" character.

Control events will show the setting of session parameters (such as Telnet), the opening and closing of a port, connecting to the server, setting a device control or status line (DTR, DSR, DCD, etc.), and the configuration of baud rate and framing parameters. They are shown in blue and are preceded by a "|" character.


Configuration Presets

Configuration Presets

Presets Description

Commonly used configurations for COM ports can be specified in an optional Presets file that contains predefined, named settings for virtual COM port options. The Presets file is a convenient way to manage settings that may need to be changed frequently.

Rather than retyping an IP address, the TCP port number, and the other configuration settings, a user can simply select them from the Presets drop-down list in the Serial/IP Control Panel.

The names of available presets will appear in a drop-down list named Presets in the Serial/IP Control Panel. If an entry is selected, then all virtual COM port settings that are specified by that entry will be applied to the currently selected virtual COM port.

The Presets drop-down list will only appear in the Serial/IP Control Panel if a presets.txt file already exists when the Serial/IP Control Panel starts.

Presets will be available for virtual COM port settings, but not for Advanced Options, as they apply to all COM ports. For security reasons, Presets do not include credential information.

The settings can also be changed directly at run-time by an application that is using the Configuration API.

Configuration may be automated during installation by using the Unattended Installation feature.

Presets Location

The Presets file is named presets.txt, and is located in the Serial/IP software installation folder.

The location of the presets file can be modified by changing the Windows registry entry PresetsFileSpec (a REG_SZ) in:

HKEY_LOCAL_MACHINE/Software/Tactical Software/SerialIP/4.0/ (for x86 PCs),

or

HKEY_LOCAL_MACHINE/Software/Wow6432Node/Tactical Software/SerialIP/4.0/ (for x64 PCs).

This will allow a Presets file to be used as a shared file for multiple users.

Entry Format

The presets.txt file is a text file that contains one or more preset entries. Each entry is on a single line, and consists of a label that is followed by one or more settings.

All entries should have the same format. The fields must appear in the order given below:

<Label>,<IP Address>,<Port Number>,<Inbound Port Number>,<Auth Option>,<Connection Protocol>,<COM Port Options>

No extra spaces are allowed, except within the Label field.

Examples

Server 1,10.0.0.251,7000,noauth

Server 2,10.0.0.252,7000,authwindows

Settings in Order of Use

Label

· Value: text string (required)
· Description: The label to be used in the Presets drop-down list in the Serial/IP Control Panel. It may contain embedded spaces. It also appears in the Activity Panel of the Port Monitor.

IP Address

· Value: xxx.xxx.xxx.xxx or hostname (required)
· Description: IP Address of Server

Port Number

· Value: valid TCP port number (required)
· Description: Port Number

Inbound Port Number

· Value: valid TCP port number
· Description: Port Number for Accept Connections

Auth Options

· Value: noauth (default)
· Description: No Login Required

· Value: authwindows
· Description: Use Windows Credentials

· Value: authloginprompt
· Description: Prompt at Login

· Value: authmanual
· Description: Use Credentials Below

· Value: authportopenprompt
· Description: Prompt on COM Port Open

Connection Protocol

· Value: telnet
· Description: Telnet

· Value: raw (default)
· Description: Raw TCP Connection

COM Port Options

· Value: dsr or dsrhigh
· Description: DSR Emulation set to Always High

· Value: dsrlow
· Description: DSR Emulation set to Always Low

· Value: dsrtrack
· Description: DSR Emulation set to Track Network Connection

· Value: nodsr (default)
· Description: DSR Emulation disabled

· Value: dcd or dcdhigh
· Description: DCD Emulation set to Always High

· Value: dcdlow
· Description: DCD Emulation set to Always Low

· Value: dcdtrack
· Description: DCD Emulation set to Track Network Connection

· Value: nodcd (default)
· Description: DCD Emulation disabled

· Value: cts or ctshigh
· Description: CTS Emulation set to Always High

· Value: ctslow
· Description: CTS Emulation set to Always Low

· Value: ctstrack
· Description: CTS Emulation set to Track Network Connection

· Value: nocts (default)
· Description: CTS Emulation disabled

· Value: dun
· Description: DTR is Modem Escape - enabled

· Value: nodun (default)
· Description: DTR is Modem Escape - disabled

· Value: reconnect
· Description: Restore Failed Connections - enabled

· Value: noreconnect (default)
· Description: Restore Failed Connections - disabled